
// This file is generated by src/Tools/generateTemplates/templateClassPyExport.py out of the .XML file
// Every change you make here gets lost in the next full rebuild!
// This File is normally built as an include in GeoFeaturePyImp.cpp! It's not intended to be in a project!

#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/exception.hpp>
#include <Base/PyObjectBase.h>
#include <Base/Console.h>
#include <Base/Exception.h>
#include <CXX/Objects.hxx>

#if defined(__clang__)
# pragma clang diagnostic push
# pragma clang diagnostic ignored "-Wdeprecated-declarations"
#endif

using Base::streq;
using namespace App;

#if defined(__GNUC__)
#pragma GCC diagnostic push
// Ignore -Wmissing-field-initializers (GCC only):
// - C++20 guarantees omitted fields are zero-initialized.
// - Python C API changes fields across versions.
// - Clang does not warn; GCC does unnecessarily.
// See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96868
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif // __GNUC__
/// Type structure of GeoFeaturePy
PyTypeObject GeoFeaturePy::Type = {
    .ob_base = PyVarObject_HEAD_INIT(&PyType_Type,0)
    .tp_name = "App.GeoFeature",
    .tp_basicsize = sizeof(GeoFeaturePy),
    .tp_itemsize = 0,
    /* methods */
    .tp_dealloc = PyDestructor,
    .tp_repr = __repr,
    .tp_getattro = __getattro,
    .tp_setattro = __setattro,
    /* --- Flags to define presence of optional/expanded features */
    .tp_flags = Py_TPFLAGS_BASETYPE|Py_TPFLAGS_DEFAULT,
    .tp_doc = "App.GeoFeature class.\n"
    "\n"
    "Base class of all geometric document objects.\n"
    "This class does the whole placement and position handling.\n"
    "With the method `getPropertyOfGeometry` is possible to obtain\n"
    "the main geometric property in general form, without reference\n"
    "to any particular property name.",
    .tp_methods = App::GeoFeaturePy::Methods,
    .tp_getset = App::GeoFeaturePy::GetterSetter,
    .tp_base = &App::DocumentObjectPy::Type,
    .tp_init = __PyInit,
    .tp_new = App::GeoFeaturePy::PyMake
};
#if defined(__GNUC__)
#pragma GCC diagnostic pop
#endif // __GNUC__

/// Methods structure of GeoFeaturePy
PyMethodDef GeoFeaturePy::Methods[] = {
    {"getPaths",
        reinterpret_cast<PyCFunction>( staticCallback_getPaths ),
        METH_VARARGS,
        "getPaths()\n"
        "\n"
        "Returns all possible paths to the root of the document.\n"
        "Note: Not implemented."
    },
    {"getGlobalPlacement",
        reinterpret_cast<PyCFunction>( staticCallback_getGlobalPlacement ),
        METH_VARARGS,
        "getGlobalPlacement() -> Base.Placement\n"
        "Deprecated: This function does not handle Links correctly. Use getGlobalPlacementOf instead.\n"
        "\n"
        "Returns the placement of the object in the global coordinate space, respecting all stacked\n"
        "relationships.\n"
        "Note: This function is not available during recompute, as there the placements of parents\n"
        "can change after the execution of this object, rendering the result wrong."
    },
    {"getGlobalPlacementOf",
        reinterpret_cast<PyCFunction>(reinterpret_cast<void (*) ()>( staticCallback_getGlobalPlacementOf )),
        METH_VARARGS|METH_STATIC,
        "getGlobalPlacementOf(targetObj, rootObj, subname) -> Base.Placement\n"
        "Selection example: obj = \"part1\" sub = \"linkToPart2.LinkToBody.Pad.face1\"\n"
        "\n"
        "Global placement of Pad in this context :\n"
        "getGlobalPlacementOf(pad, part1, \"linkToPart2.LinkToBody.Pad.face1\")\n"
        "\n"
        "Global placement of linkToPart2 in this context :\n"
        "getGlobalPlacementOf(linkToPart2, part1, \"linkToPart2.LinkToBody.Pad.face1\")\n"
        "\n"
        "Returns the placement of the object in the global coordinate space, respecting all stacked\n"
        "relationships."
    },
    {"getPropertyNameOfGeometry",
        reinterpret_cast<PyCFunction>( staticCallback_getPropertyNameOfGeometry ),
        METH_VARARGS,
        "getPropertyNameOfGeometry() -> str or None\n"
        "\n"
        "Returns the property name of the actual geometry.\n"
        "For example for a Part feature it returns the value 'Shape', for a mesh feature the value\n"
        "'Mesh' and so on.\n"
        "If an object has no such property then None is returned."
    },
    {"getPropertyOfGeometry",
        reinterpret_cast<PyCFunction>( staticCallback_getPropertyOfGeometry ),
        METH_VARARGS,
        "getPropertyOfGeometry() -> object or None\n"
        "\n"
        "Returns the property of the actual geometry.\n"
        "For example for a Part feature it returns its Shape property, for a Mesh feature its\n"
        "Mesh property and so on.\n"
        "If an object has no such property then None is returned.\n"
        "Unlike to getPropertyNameOfGeometry this function returns the geometry, not its name."
    },
    {nullptr, nullptr, 0, nullptr}		/* Sentinel */
};



/// Attribute structure of GeoFeaturePy
PyGetSetDef GeoFeaturePy::GetterSetter[] = {
    {"ElementMapVersion",
        (getter) staticCallback_getElementMapVersion,
        (setter) staticCallback_setElementMapVersion,
        "Element map version",
        nullptr
    },
    {nullptr, nullptr, nullptr, nullptr, nullptr}		/* Sentinel */
};

// getPaths() callback and implementer
// PyObject*  GeoFeaturePy::getPaths(PyObject *args){};
// has to be implemented in GeoFeaturePyImp.cpp
PyObject * GeoFeaturePy::staticCallback_getPaths (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'getPaths' of 'App.GeoFeature' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<GeoFeaturePy*>(self)->getPaths(args);
        if (ret != nullptr)
            static_cast<GeoFeaturePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return nullptr;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// getGlobalPlacement() callback and implementer
// PyObject*  GeoFeaturePy::getGlobalPlacement(PyObject *args){};
// has to be implemented in GeoFeaturePyImp.cpp
PyObject * GeoFeaturePy::staticCallback_getGlobalPlacement (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'getGlobalPlacement' of 'App.GeoFeature' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<GeoFeaturePy*>(self)->getGlobalPlacement(args);
        if (ret != nullptr)
            static_cast<GeoFeaturePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return nullptr;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// getGlobalPlacementOf() callback and implementer
// PyObject*  GeoFeaturePy::getGlobalPlacementOf(PyObject *args){};
// has to be implemented in GeoFeaturePyImp.cpp
PyObject * GeoFeaturePy::staticCallback_getGlobalPlacementOf (PyObject *self, PyObject *args)
{
    try { // catches all exceptions coming up from c++ and generate a python exception
        (void)self;
        PyObject* ret = GeoFeaturePy::getGlobalPlacementOf(args);
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return nullptr;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// getPropertyNameOfGeometry() callback and implementer
// PyObject*  GeoFeaturePy::getPropertyNameOfGeometry(PyObject *args){};
// has to be implemented in GeoFeaturePyImp.cpp
PyObject * GeoFeaturePy::staticCallback_getPropertyNameOfGeometry (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'getPropertyNameOfGeometry' of 'App.GeoFeature' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<GeoFeaturePy*>(self)->getPropertyNameOfGeometry(args);
        if (ret != nullptr)
            static_cast<GeoFeaturePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return nullptr;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// getPropertyOfGeometry() callback and implementer
// PyObject*  GeoFeaturePy::getPropertyOfGeometry(PyObject *args){};
// has to be implemented in GeoFeaturePyImp.cpp
PyObject * GeoFeaturePy::staticCallback_getPropertyOfGeometry (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'getPropertyOfGeometry' of 'App.GeoFeature' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<GeoFeaturePy*>(self)->getPropertyOfGeometry(args);
        if (ret != nullptr)
            static_cast<GeoFeaturePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return nullptr;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// ElementMapVersion() callback and implementer
// PyObject*  GeoFeaturePy::ElementMapVersion(PyObject *args){};
// has to be implemented in GeoFeaturePyImp.cpp
PyObject * GeoFeaturePy::staticCallback_getElementMapVersion (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<GeoFeaturePy*>(self)->getElementMapVersion());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'ElementMapVersion' of object 'GeoFeature'");
        return nullptr;
    }
}

int GeoFeaturePy::staticCallback_setElementMapVersion (PyObject *self, PyObject * /*value*/, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }

    PyErr_SetString(PyExc_AttributeError, "Attribute 'ElementMapVersion' of object 'GeoFeature' is read-only");
    return -1;
}




//--------------------------------------------------------------------------
// Constructor
//--------------------------------------------------------------------------
GeoFeaturePy::GeoFeaturePy(GeoFeature *pcObject, PyTypeObject *T)
    : DocumentObjectPy(static_cast<DocumentObjectPy::PointerType>(pcObject), T)
{
}

PyObject *GeoFeaturePy::PyMake(PyTypeObject* /*type*/, PyObject* /*args*/, PyObject* /*kwds*/)
{
    // never create such objects with the constructor
    PyErr_SetString(PyExc_RuntimeError, "You cannot create directly an instance of 'GeoFeaturePy'.");

    return nullptr;
}

int GeoFeaturePy::PyInit(PyObject* /*args*/, PyObject* /*kwd*/)
{
    return 0;
}

//--------------------------------------------------------------------------
// destructor
//--------------------------------------------------------------------------
GeoFeaturePy::~GeoFeaturePy()                                // Everything handled in parent
{
}

//--------------------------------------------------------------------------
// GeoFeaturePy representation
//--------------------------------------------------------------------------
PyObject *GeoFeaturePy::_repr()
{
    return Py_BuildValue("s", representation().c_str());
}

//--------------------------------------------------------------------------
// GeoFeaturePy Attributes
//--------------------------------------------------------------------------
PyObject *GeoFeaturePy::_getattr(const char *attr)			// __getattr__ function: note only need to handle new state
{
    try {
        // getter method for special Attributes (e.g. dynamic ones)
        PyObject *r = getCustomAttributes(attr);
        if(r) return r;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return nullptr;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError,"Unknown C++ exception");
        return nullptr;
    }
#endif

    PyMethodDef *ml = Methods;
    for (; ml->ml_name != nullptr; ml++) {
        if (attr[0] == ml->ml_name[0] &&
            strcmp(attr+1, ml->ml_name+1) == 0)
            return PyCFunction_New(ml, this);
    }

    PyErr_Clear();
    return DocumentObjectPy::_getattr(attr);
}

int GeoFeaturePy::_setattr(const char *attr, PyObject *value) // __setattr__ function: note only need to handle new state
{
    try {
        // setter for special Attributes (e.g. dynamic ones)
        int r = setCustomAttributes(attr, value);
        // r = 1: handled
        // r = -1: error
        // r = 0: ignore
        if (r == 1)
            return 0;
        else if (r == -1)
            return -1;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return -1;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return -1;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return -1;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return -1;
    }
#endif

    return DocumentObjectPy::_setattr(attr, value);
}

GeoFeature *GeoFeaturePy::getGeoFeaturePtr() const
{
    return static_cast<GeoFeature *>(_pcTwinPointer);
}

#if defined(__clang__)
# pragma clang diagnostic pop
#endif

#if 0
/* From here on come the methods you have to implement, but NOT in this module. Implement in GeoFeaturePyImp.cpp! This prototypes
 * are just for convenience when you add a new method.
 */



// returns a string which represents the object e.g. when printed in python
std::string GeoFeaturePy::representation() const
{
    return {"<GeoFeature object>"};
}

PyObject* GeoFeaturePy::getPaths(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* GeoFeaturePy::getGlobalPlacement(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* GeoFeaturePy::getGlobalPlacementOf(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* GeoFeaturePy::getPropertyNameOfGeometry(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* GeoFeaturePy::getPropertyOfGeometry(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}



Py::String GeoFeaturePy::getElementMapVersion() const
{
    //return Py::String();
    throw Py::AttributeError("Not yet implemented");
}

PyObject *GeoFeaturePy::getCustomAttributes(const char* /*attr*/) const
{
    return nullptr;
}

int GeoFeaturePy::setCustomAttributes(const char* /*attr*/, PyObject* /*obj*/)
{
    return 0;
}


#endif



