
// This file is generated by src/Tools/generateTemplates/templateClassPyExport.py out of the .XML file
// Every change you make here gets lost in the next full rebuild!
// This File is normally built as an include in MaterialFilterOptionsPyImp.cpp! It's not intended to be in a project!

#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/exception.hpp>
#include <Base/PyObjectBase.h>
#include <Base/Console.h>
#include <Base/Exception.h>
#include <CXX/Objects.hxx>

#if defined(__clang__)
# pragma clang diagnostic push
# pragma clang diagnostic ignored "-Wdeprecated-declarations"
#endif

using Base::streq;
using namespace Materials;

#if defined(__GNUC__)
#pragma GCC diagnostic push
// Ignore -Wmissing-field-initializers (GCC only):
// - C++20 guarantees omitted fields are zero-initialized.
// - Python C API changes fields across versions.
// - Clang does not warn; GCC does unnecessarily.
// See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96868
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif // __GNUC__
/// Type structure of MaterialFilterOptionsPy
PyTypeObject MaterialFilterOptionsPy::Type = {
    .ob_base = PyVarObject_HEAD_INIT(&PyType_Type,0)
    .tp_name = "Materials.MaterialFilterOptions",
    .tp_basicsize = sizeof(MaterialFilterOptionsPy),
    .tp_itemsize = 0,
    /* methods */
    .tp_dealloc = PyDestructor,
    .tp_repr = __repr,
    .tp_getattro = __getattro,
    .tp_setattro = __setattro,
    /* --- Flags to define presence of optional/expanded features */
    .tp_flags = Py_TPFLAGS_BASETYPE|Py_TPFLAGS_DEFAULT,
    .tp_doc = "Material filtering options.",
    .tp_methods = Materials::MaterialFilterOptionsPy::Methods,
    .tp_getset = Materials::MaterialFilterOptionsPy::GetterSetter,
    .tp_base = &Base::BaseClassPy::Type,
    .tp_init = __PyInit,
    .tp_new = Materials::MaterialFilterOptionsPy::PyMake
};
#if defined(__GNUC__)
#pragma GCC diagnostic pop
#endif // __GNUC__

/// Methods structure of MaterialFilterOptionsPy
PyMethodDef MaterialFilterOptionsPy::Methods[] = {
    {nullptr, nullptr, 0, nullptr}		/* Sentinel */
};



/// Attribute structure of MaterialFilterOptionsPy
PyGetSetDef MaterialFilterOptionsPy::GetterSetter[] = {
    {"IncludeFavorites",
        (getter) staticCallback_getIncludeFavorites,
        (setter) staticCallback_setIncludeFavorites,
        "Include materials marked as favorite.",
        nullptr
    },
    {"IncludeRecent",
        (getter) staticCallback_getIncludeRecent,
        (setter) staticCallback_setIncludeRecent,
        "Include recently used materials.",
        nullptr
    },
    {"IncludeEmptyFolders",
        (getter) staticCallback_getIncludeEmptyFolders,
        (setter) staticCallback_setIncludeEmptyFolders,
        "Include empty folders.",
        nullptr
    },
    {"IncludeEmptyLibraries",
        (getter) staticCallback_getIncludeEmptyLibraries,
        (setter) staticCallback_setIncludeEmptyLibraries,
        "Include empty libraries.",
        nullptr
    },
    {"IncludeLegacy",
        (getter) staticCallback_getIncludeLegacy,
        (setter) staticCallback_setIncludeLegacy,
        "Include materials using the older legacy format.",
        nullptr
    },
    {nullptr, nullptr, nullptr, nullptr, nullptr}		/* Sentinel */
};

// IncludeFavorites() callback and implementer
// PyObject*  MaterialFilterOptionsPy::IncludeFavorites(PyObject *args){};
// has to be implemented in MaterialFilterOptionsPyImp.cpp
PyObject * MaterialFilterOptionsPy::staticCallback_getIncludeFavorites (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialFilterOptionsPy*>(self)->getIncludeFavorites());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'IncludeFavorites' of object 'MaterialFilterOptions'");
        return nullptr;
    }
}

int MaterialFilterOptionsPy::staticCallback_setIncludeFavorites (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialFilterOptionsPy*>(self)->setIncludeFavorites(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'IncludeFavorites' of object 'MaterialFilterOptions'");
        return -1;
    }
}

// IncludeRecent() callback and implementer
// PyObject*  MaterialFilterOptionsPy::IncludeRecent(PyObject *args){};
// has to be implemented in MaterialFilterOptionsPyImp.cpp
PyObject * MaterialFilterOptionsPy::staticCallback_getIncludeRecent (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialFilterOptionsPy*>(self)->getIncludeRecent());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'IncludeRecent' of object 'MaterialFilterOptions'");
        return nullptr;
    }
}

int MaterialFilterOptionsPy::staticCallback_setIncludeRecent (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialFilterOptionsPy*>(self)->setIncludeRecent(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'IncludeRecent' of object 'MaterialFilterOptions'");
        return -1;
    }
}

// IncludeEmptyFolders() callback and implementer
// PyObject*  MaterialFilterOptionsPy::IncludeEmptyFolders(PyObject *args){};
// has to be implemented in MaterialFilterOptionsPyImp.cpp
PyObject * MaterialFilterOptionsPy::staticCallback_getIncludeEmptyFolders (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialFilterOptionsPy*>(self)->getIncludeEmptyFolders());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'IncludeEmptyFolders' of object 'MaterialFilterOptions'");
        return nullptr;
    }
}

int MaterialFilterOptionsPy::staticCallback_setIncludeEmptyFolders (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialFilterOptionsPy*>(self)->setIncludeEmptyFolders(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'IncludeEmptyFolders' of object 'MaterialFilterOptions'");
        return -1;
    }
}

// IncludeEmptyLibraries() callback and implementer
// PyObject*  MaterialFilterOptionsPy::IncludeEmptyLibraries(PyObject *args){};
// has to be implemented in MaterialFilterOptionsPyImp.cpp
PyObject * MaterialFilterOptionsPy::staticCallback_getIncludeEmptyLibraries (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialFilterOptionsPy*>(self)->getIncludeEmptyLibraries());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'IncludeEmptyLibraries' of object 'MaterialFilterOptions'");
        return nullptr;
    }
}

int MaterialFilterOptionsPy::staticCallback_setIncludeEmptyLibraries (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialFilterOptionsPy*>(self)->setIncludeEmptyLibraries(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'IncludeEmptyLibraries' of object 'MaterialFilterOptions'");
        return -1;
    }
}

// IncludeLegacy() callback and implementer
// PyObject*  MaterialFilterOptionsPy::IncludeLegacy(PyObject *args){};
// has to be implemented in MaterialFilterOptionsPyImp.cpp
PyObject * MaterialFilterOptionsPy::staticCallback_getIncludeLegacy (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialFilterOptionsPy*>(self)->getIncludeLegacy());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'IncludeLegacy' of object 'MaterialFilterOptions'");
        return nullptr;
    }
}

int MaterialFilterOptionsPy::staticCallback_setIncludeLegacy (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialFilterOptionsPy*>(self)->setIncludeLegacy(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'IncludeLegacy' of object 'MaterialFilterOptions'");
        return -1;
    }
}




//--------------------------------------------------------------------------
// Constructor
//--------------------------------------------------------------------------
MaterialFilterOptionsPy::MaterialFilterOptionsPy(MaterialFilterOptions *pcObject, PyTypeObject *T)
    : BaseClassPy(static_cast<BaseClassPy::PointerType>(pcObject), T)
{
}


//--------------------------------------------------------------------------
// destructor
//--------------------------------------------------------------------------
MaterialFilterOptionsPy::~MaterialFilterOptionsPy()                                // Everything handled in parent
{
    // delete the handled object when the PyObject dies
    MaterialFilterOptionsPy::PointerType ptr = static_cast<MaterialFilterOptionsPy::PointerType>(_pcTwinPointer);
    delete ptr;
}

//--------------------------------------------------------------------------
// MaterialFilterOptionsPy representation
//--------------------------------------------------------------------------
PyObject *MaterialFilterOptionsPy::_repr()
{
    return Py_BuildValue("s", representation().c_str());
}

//--------------------------------------------------------------------------
// MaterialFilterOptionsPy Attributes
//--------------------------------------------------------------------------
PyObject *MaterialFilterOptionsPy::_getattr(const char *attr)			// __getattr__ function: note only need to handle new state
{
    try {
        // getter method for special Attributes (e.g. dynamic ones)
        PyObject *r = getCustomAttributes(attr);
        if(r) return r;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return nullptr;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError,"Unknown C++ exception");
        return nullptr;
    }
#endif

    PyMethodDef *ml = Methods;
    for (; ml->ml_name != nullptr; ml++) {
        if (attr[0] == ml->ml_name[0] &&
            strcmp(attr+1, ml->ml_name+1) == 0)
            return PyCFunction_New(ml, this);
    }

    PyErr_Clear();
    return BaseClassPy::_getattr(attr);
}

int MaterialFilterOptionsPy::_setattr(const char *attr, PyObject *value) // __setattr__ function: note only need to handle new state
{
    try {
        // setter for special Attributes (e.g. dynamic ones)
        int r = setCustomAttributes(attr, value);
        // r = 1: handled
        // r = -1: error
        // r = 0: ignore
        if (r == 1)
            return 0;
        else if (r == -1)
            return -1;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return -1;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return -1;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return -1;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return -1;
    }
#endif

    return BaseClassPy::_setattr(attr, value);
}

MaterialFilterOptions *MaterialFilterOptionsPy::getMaterialFilterOptionsPtr() const
{
    return static_cast<MaterialFilterOptions *>(_pcTwinPointer);
}

#if defined(__clang__)
# pragma clang diagnostic pop
#endif

#if 0
/* From here on come the methods you have to implement, but NOT in this module. Implement in MaterialFilterOptionsPyImp.cpp! This prototypes
 * are just for convenience when you add a new method.
 */

PyObject *MaterialFilterOptionsPy::PyMake(PyTypeObject* /*type*/, PyObject* /*args*/, PyObject* /*kwds*/)
{
    // create a new instance of MaterialFilterOptionsPy and the Twin object
    return new MaterialFilterOptionsPy(new MaterialFilterOptions);
}

// constructor method
int MaterialFilterOptionsPy::PyInit(PyObject* /*args*/, PyObject* /*kwd*/)
{
    return 0;
}


// returns a string which represents the object e.g. when printed in python
std::string MaterialFilterOptionsPy::representation() const
{
    return {"<MaterialFilterOptions object>"};
}



Py::Boolean MaterialFilterOptionsPy::getIncludeFavorites() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialFilterOptionsPy::setIncludeFavorites(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean MaterialFilterOptionsPy::getIncludeRecent() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialFilterOptionsPy::setIncludeRecent(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean MaterialFilterOptionsPy::getIncludeEmptyFolders() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialFilterOptionsPy::setIncludeEmptyFolders(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean MaterialFilterOptionsPy::getIncludeEmptyLibraries() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialFilterOptionsPy::setIncludeEmptyLibraries(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean MaterialFilterOptionsPy::getIncludeLegacy() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialFilterOptionsPy::setIncludeLegacy(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

PyObject *MaterialFilterOptionsPy::getCustomAttributes(const char* /*attr*/) const
{
    return nullptr;
}

int MaterialFilterOptionsPy::setCustomAttributes(const char* /*attr*/, PyObject* /*obj*/)
{
    return 0;
}


#endif



