
// This file is generated by src/Tools/generateTemplates/templateClassPyExport.py out of the .XML file
// Every change you make here gets lost in the next full rebuild!
// This File is normally built as an include in MaterialTreeWidgetPyImp.cpp! It's not intended to be in a project!

#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/exception.hpp>
#include <Base/PyObjectBase.h>
#include <Base/Console.h>
#include <Base/Exception.h>
#include <CXX/Objects.hxx>

#if defined(__clang__)
# pragma clang diagnostic push
# pragma clang diagnostic ignored "-Wdeprecated-declarations"
#endif

using Base::streq;
using namespace MatGui;

#if defined(__GNUC__)
#pragma GCC diagnostic push
// Ignore -Wmissing-field-initializers (GCC only):
// - C++20 guarantees omitted fields are zero-initialized.
// - Python C API changes fields across versions.
// - Clang does not warn; GCC does unnecessarily.
// See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96868
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif // __GNUC__
/// Type structure of MaterialTreeWidgetPy
PyTypeObject MaterialTreeWidgetPy::Type = {
    .ob_base = PyVarObject_HEAD_INIT(&PyType_Type,0)
    .tp_name = "MatGui.MaterialTreeWidget",
    .tp_basicsize = sizeof(MaterialTreeWidgetPy),
    .tp_itemsize = 0,
    /* methods */
    .tp_dealloc = PyDestructor,
    .tp_repr = __repr,
    .tp_getattro = __getattro,
    .tp_setattro = __setattro,
    /* --- Flags to define presence of optional/expanded features */
    .tp_flags = Py_TPFLAGS_BASETYPE|Py_TPFLAGS_DEFAULT,
    .tp_doc = "Material tree widget.",
    .tp_methods = MatGui::MaterialTreeWidgetPy::Methods,
    .tp_getset = MatGui::MaterialTreeWidgetPy::GetterSetter,
    .tp_base = &Base::BaseClassPy::Type,
    .tp_init = __PyInit,
    .tp_new = MatGui::MaterialTreeWidgetPy::PyMake
};
#if defined(__GNUC__)
#pragma GCC diagnostic pop
#endif // __GNUC__

/// Methods structure of MaterialTreeWidgetPy
PyMethodDef MaterialTreeWidgetPy::Methods[] = {
    {"setFilter",
        reinterpret_cast<PyCFunction>( staticCallback_setFilter ),
        METH_VARARGS,
        "Set the material filter or list of filters."
    },
    {"selectFilter",
        reinterpret_cast<PyCFunction>( staticCallback_selectFilter ),
        METH_VARARGS,
        "Set the current material filter."
    },
    {nullptr, nullptr, 0, nullptr}		/* Sentinel */
};



/// Attribute structure of MaterialTreeWidgetPy
PyGetSetDef MaterialTreeWidgetPy::GetterSetter[] = {
    {"UUID",
        (getter) staticCallback_getUUID,
        (setter) staticCallback_setUUID,
        "Material UUID.",
        nullptr
    },
    {"expanded",
        (getter) staticCallback_getexpanded,
        (setter) staticCallback_setexpanded,
        "Expand material tree.",
        nullptr
    },
    {"IncludeFavorites",
        (getter) staticCallback_getIncludeFavorites,
        (setter) staticCallback_setIncludeFavorites,
        "Include favorites in the material list.",
        nullptr
    },
    {"IncludeRecent",
        (getter) staticCallback_getIncludeRecent,
        (setter) staticCallback_setIncludeRecent,
        "Include recently used materials in the material list.",
        nullptr
    },
    {"IncludeEmptyFolders",
        (getter) staticCallback_getIncludeEmptyFolders,
        (setter) staticCallback_setIncludeEmptyFolders,
        "Include empty folders in the material list.",
        nullptr
    },
    {"IncludeEmptyLibraries",
        (getter) staticCallback_getIncludeEmptyLibraries,
        (setter) staticCallback_setIncludeEmptyLibraries,
        "Include empty libraries in the material list.",
        nullptr
    },
    {"IncludeLegacy",
        (getter) staticCallback_getIncludeLegacy,
        (setter) staticCallback_setIncludeLegacy,
        "Include legacy materials in the material list.",
        nullptr
    },
    {nullptr, nullptr, nullptr, nullptr, nullptr}		/* Sentinel */
};

// setFilter() callback and implementer
// PyObject*  MaterialTreeWidgetPy::setFilter(PyObject *args){};
// has to be implemented in MaterialTreeWidgetPyImp.cpp
PyObject * MaterialTreeWidgetPy::staticCallback_setFilter (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'setFilter' of 'MatGui.MaterialTreeWidget' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<MaterialTreeWidgetPy*>(self)->setFilter(args);
        if (ret != nullptr)
            static_cast<MaterialTreeWidgetPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return nullptr;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// selectFilter() callback and implementer
// PyObject*  MaterialTreeWidgetPy::selectFilter(PyObject *args){};
// has to be implemented in MaterialTreeWidgetPyImp.cpp
PyObject * MaterialTreeWidgetPy::staticCallback_selectFilter (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'selectFilter' of 'MatGui.MaterialTreeWidget' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<MaterialTreeWidgetPy*>(self)->selectFilter(args);
        if (ret != nullptr)
            static_cast<MaterialTreeWidgetPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return nullptr;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// UUID() callback and implementer
// PyObject*  MaterialTreeWidgetPy::UUID(PyObject *args){};
// has to be implemented in MaterialTreeWidgetPyImp.cpp
PyObject * MaterialTreeWidgetPy::staticCallback_getUUID (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialTreeWidgetPy*>(self)->getUUID());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'UUID' of object 'MaterialTreeWidget'");
        return nullptr;
    }
}

int MaterialTreeWidgetPy::staticCallback_setUUID (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialTreeWidgetPy*>(self)->setUUID(Py::String(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'UUID' of object 'MaterialTreeWidget'");
        return -1;
    }
}

// expanded() callback and implementer
// PyObject*  MaterialTreeWidgetPy::expanded(PyObject *args){};
// has to be implemented in MaterialTreeWidgetPyImp.cpp
PyObject * MaterialTreeWidgetPy::staticCallback_getexpanded (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialTreeWidgetPy*>(self)->getexpanded());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'expanded' of object 'MaterialTreeWidget'");
        return nullptr;
    }
}

int MaterialTreeWidgetPy::staticCallback_setexpanded (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialTreeWidgetPy*>(self)->setexpanded(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'expanded' of object 'MaterialTreeWidget'");
        return -1;
    }
}

// IncludeFavorites() callback and implementer
// PyObject*  MaterialTreeWidgetPy::IncludeFavorites(PyObject *args){};
// has to be implemented in MaterialTreeWidgetPyImp.cpp
PyObject * MaterialTreeWidgetPy::staticCallback_getIncludeFavorites (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialTreeWidgetPy*>(self)->getIncludeFavorites());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'IncludeFavorites' of object 'MaterialTreeWidget'");
        return nullptr;
    }
}

int MaterialTreeWidgetPy::staticCallback_setIncludeFavorites (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialTreeWidgetPy*>(self)->setIncludeFavorites(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'IncludeFavorites' of object 'MaterialTreeWidget'");
        return -1;
    }
}

// IncludeRecent() callback and implementer
// PyObject*  MaterialTreeWidgetPy::IncludeRecent(PyObject *args){};
// has to be implemented in MaterialTreeWidgetPyImp.cpp
PyObject * MaterialTreeWidgetPy::staticCallback_getIncludeRecent (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialTreeWidgetPy*>(self)->getIncludeRecent());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'IncludeRecent' of object 'MaterialTreeWidget'");
        return nullptr;
    }
}

int MaterialTreeWidgetPy::staticCallback_setIncludeRecent (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialTreeWidgetPy*>(self)->setIncludeRecent(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'IncludeRecent' of object 'MaterialTreeWidget'");
        return -1;
    }
}

// IncludeEmptyFolders() callback and implementer
// PyObject*  MaterialTreeWidgetPy::IncludeEmptyFolders(PyObject *args){};
// has to be implemented in MaterialTreeWidgetPyImp.cpp
PyObject * MaterialTreeWidgetPy::staticCallback_getIncludeEmptyFolders (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialTreeWidgetPy*>(self)->getIncludeEmptyFolders());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'IncludeEmptyFolders' of object 'MaterialTreeWidget'");
        return nullptr;
    }
}

int MaterialTreeWidgetPy::staticCallback_setIncludeEmptyFolders (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialTreeWidgetPy*>(self)->setIncludeEmptyFolders(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'IncludeEmptyFolders' of object 'MaterialTreeWidget'");
        return -1;
    }
}

// IncludeEmptyLibraries() callback and implementer
// PyObject*  MaterialTreeWidgetPy::IncludeEmptyLibraries(PyObject *args){};
// has to be implemented in MaterialTreeWidgetPyImp.cpp
PyObject * MaterialTreeWidgetPy::staticCallback_getIncludeEmptyLibraries (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialTreeWidgetPy*>(self)->getIncludeEmptyLibraries());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'IncludeEmptyLibraries' of object 'MaterialTreeWidget'");
        return nullptr;
    }
}

int MaterialTreeWidgetPy::staticCallback_setIncludeEmptyLibraries (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialTreeWidgetPy*>(self)->setIncludeEmptyLibraries(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'IncludeEmptyLibraries' of object 'MaterialTreeWidget'");
        return -1;
    }
}

// IncludeLegacy() callback and implementer
// PyObject*  MaterialTreeWidgetPy::IncludeLegacy(PyObject *args){};
// has to be implemented in MaterialTreeWidgetPyImp.cpp
PyObject * MaterialTreeWidgetPy::staticCallback_getIncludeLegacy (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<MaterialTreeWidgetPy*>(self)->getIncludeLegacy());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'IncludeLegacy' of object 'MaterialTreeWidget'");
        return nullptr;
    }
}

int MaterialTreeWidgetPy::staticCallback_setIncludeLegacy (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<MaterialTreeWidgetPy*>(self)->setIncludeLegacy(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'IncludeLegacy' of object 'MaterialTreeWidget'");
        return -1;
    }
}




//--------------------------------------------------------------------------
// Constructor
//--------------------------------------------------------------------------
MaterialTreeWidgetPy::MaterialTreeWidgetPy(MaterialTreeWidget *pcObject, PyTypeObject *T)
    : BaseClassPy(static_cast<BaseClassPy::PointerType>(pcObject), T)
{
}


//--------------------------------------------------------------------------
// destructor
//--------------------------------------------------------------------------
MaterialTreeWidgetPy::~MaterialTreeWidgetPy()                                // Everything handled in parent
{
}

//--------------------------------------------------------------------------
// MaterialTreeWidgetPy representation
//--------------------------------------------------------------------------
PyObject *MaterialTreeWidgetPy::_repr()
{
    return Py_BuildValue("s", representation().c_str());
}

//--------------------------------------------------------------------------
// MaterialTreeWidgetPy Attributes
//--------------------------------------------------------------------------
PyObject *MaterialTreeWidgetPy::_getattr(const char *attr)			// __getattr__ function: note only need to handle new state
{
    try {
        // getter method for special Attributes (e.g. dynamic ones)
        PyObject *r = getCustomAttributes(attr);
        if(r) return r;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return nullptr;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError,"Unknown C++ exception");
        return nullptr;
    }
#endif

    PyMethodDef *ml = Methods;
    for (; ml->ml_name != nullptr; ml++) {
        if (attr[0] == ml->ml_name[0] &&
            strcmp(attr+1, ml->ml_name+1) == 0)
            return PyCFunction_New(ml, this);
    }

    PyErr_Clear();
    return BaseClassPy::_getattr(attr);
}

int MaterialTreeWidgetPy::_setattr(const char *attr, PyObject *value) // __setattr__ function: note only need to handle new state
{
    try {
        // setter for special Attributes (e.g. dynamic ones)
        int r = setCustomAttributes(attr, value);
        // r = 1: handled
        // r = -1: error
        // r = 0: ignore
        if (r == 1)
            return 0;
        else if (r == -1)
            return -1;
    } // Please sync the following catch implementation with PY_CATCH
    catch(Base::Exception &e)
    {
        auto pye = e.getPyExceptionType();
        if(!pye)
            pye = Base::PyExc_FC_GeneralError;
        PyErr_SetObject(pye, e.getPyObject());
        return -1;
    }
    catch(const std::exception &e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return -1;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return -1;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return -1;
    }
#endif

    return BaseClassPy::_setattr(attr, value);
}

MaterialTreeWidget *MaterialTreeWidgetPy::getMaterialTreeWidgetPtr() const
{
    return static_cast<MaterialTreeWidget *>(_pcTwinPointer);
}

#if defined(__clang__)
# pragma clang diagnostic pop
#endif

#if 0
/* From here on come the methods you have to implement, but NOT in this module. Implement in MaterialTreeWidgetPyImp.cpp! This prototypes
 * are just for convenience when you add a new method.
 */

PyObject *MaterialTreeWidgetPy::PyMake(PyTypeObject* /*type*/, PyObject* /*args*/, PyObject* /*kwds*/)
{
    // create a new instance of MaterialTreeWidgetPy and the Twin object
    return new MaterialTreeWidgetPy(new MaterialTreeWidget);
}

// constructor method
int MaterialTreeWidgetPy::PyInit(PyObject* /*args*/, PyObject* /*kwd*/)
{
    return 0;
}


// returns a string which represents the object e.g. when printed in python
std::string MaterialTreeWidgetPy::representation() const
{
    return {"<MaterialTreeWidget object>"};
}

PyObject* MaterialTreeWidgetPy::setFilter(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* MaterialTreeWidgetPy::selectFilter(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}



Py::String MaterialTreeWidgetPy::getUUID() const
{
    //return Py::String();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialTreeWidgetPy::setUUID(Py::String arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean MaterialTreeWidgetPy::getexpanded() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialTreeWidgetPy::setexpanded(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean MaterialTreeWidgetPy::getIncludeFavorites() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialTreeWidgetPy::setIncludeFavorites(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean MaterialTreeWidgetPy::getIncludeRecent() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialTreeWidgetPy::setIncludeRecent(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean MaterialTreeWidgetPy::getIncludeEmptyFolders() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialTreeWidgetPy::setIncludeEmptyFolders(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean MaterialTreeWidgetPy::getIncludeEmptyLibraries() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialTreeWidgetPy::setIncludeEmptyLibraries(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean MaterialTreeWidgetPy::getIncludeLegacy() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  MaterialTreeWidgetPy::setIncludeLegacy(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

PyObject *MaterialTreeWidgetPy::getCustomAttributes(const char* /*attr*/) const
{
    return nullptr;
}

int MaterialTreeWidgetPy::setCustomAttributes(const char* /*attr*/, PyObject* /*obj*/)
{
    return 0;
}


#endif



